using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 귯 Ʈ ڽ
    /// </summary>
    public class BrushListBox : ListBox
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 귯 Ÿ
        /// </summary>
        private BrushType brushType;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 귯 Ÿ - BrushType

        /// <summary>
        /// 귯 Ÿ
        /// </summary>
        public BrushType BrushType
        {
            get
            {
                return this.brushType;
            }
            set 
            {
                this.brushType = value;

                Initialize();
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - BrushListBox()

        /// <summary>
        /// 
        /// </summary>
        public BrushListBox()
        {
            DrawMode  = DrawMode.OwnerDrawFixed;
            BrushType = BrushType.HATCH;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region ׸ ׸ óϱ - OnDrawItem(e)

        /// <summary>
        /// ׸ ׸ óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnDrawItem(DrawItemEventArgs e)
        {
            Graphics graphics = e.Graphics;

            e.DrawBackground();

            if(e.Index >= 0 && e.Index < Items.Count)
            {
                IBrushItem brushItem = (IBrushItem)Items[e.Index];
                Brush      brush     = brushItem.Brush;

                graphics.FillRectangle(brush, e.Bounds);

                graphics.DrawLine(Pens.Black, e.Bounds.X, e.Bounds.Bottom - 1, e.Bounds.Right, e.Bounds.Bottom - 1);

                string brushItemName = brushItem.Name;
                int    width         = (int)graphics.MeasureString(brushItemName, Font).Width;

                graphics.FillRectangle((e.State & DrawItemState.Selected) == DrawItemState.Selected ? Brushes.Yellow : Brushes.White, 3, e.Bounds.Top + 3, width + 3, Font.Height + 5);

                graphics.DrawRectangle(Pens.Black, 3, e.Bounds.Top + 3, width + 3, Font.Height + 5);

                graphics.DrawString(brushItem.Name, Font, Brushes.Black, 5, e.Bounds.Top + 5);

                brush.Dispose();
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region ʱȭϱ - Initialize()

        /// <summary>
        /// ʱȭϱ
        /// </summary>
        private void Initialize()
        {
            Items.Clear();

            if(this.brushType == BrushType.HATCH)
            {
                foreach(HatchStyle hatchStyle in Enum.GetValues(typeof(HatchStyle)))
                {
                    IBrushItem brushItem = new HatchBrushItem(hatchStyle, Color.Blue, Color.Transparent);

                    Items.Add(brushItem);
                }
            }
            else if(this.brushType == BrushType.SOLID_COLOR)
            {
                foreach(KnownColor knownColor in Enum.GetValues(typeof(KnownColor)))
                {
                    Color color = Color.FromKnownColor(knownColor);

                    if(!color.IsSystemColor)
                    {
                        IBrushItem brushItem = new ColorBrushItem(color);

                        Items.Add(brushItem);
                    }
                }
            }
            else if(this.brushType == BrushType.SYSTEM_COLOR)
            {
                foreach(KnownColor knownColor in Enum.GetValues(typeof(KnownColor)))
                {
                    Color color = Color.FromKnownColor(knownColor);

                    if(color.IsSystemColor)
                    {
                        IBrushItem brushItem = new ColorBrushItem(color);

                        Items.Add(brushItem);
                    }
                }
            }
        }

        #endregion
    }
}