﻿using System.Drawing;
using System.Drawing.Drawing2D;

namespace TestProject
{
    /// <summary>
    /// 해시 브러시 항목
    /// </summary>
    public class HatchBrushItem : IBrushItem
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 해치 스타일
        /// </summary>
        private HatchStyle hatchStyle;

        /// <summary>
        /// 전경색
        /// </summary>
        private Color foregroundColor;

        /// <summary>
        /// 배경색
        /// </summary>
        private Color backgroundColor;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 명칭 - Name

        /// <summary>
        /// 명칭
        /// </summary>
        public string Name
        {
            get
            {
                return this.hatchStyle.ToString();
            }
        }

        #endregion
        #region 브러시 - Brush

        /// <summary>
        /// 브러시
        /// </summary>
        public Brush Brush
        {
            get
            {
                return new HatchBrush(this.hatchStyle, this.foregroundColor, this.backgroundColor);
            }
        }

        #endregion
        #region 전경색 - ForegroundColor

        /// <summary>
        /// 전경색
        /// </summary>
        public Color ForegroundColor
        {
            get
            {
                return this.foregroundColor;
            }
        }

        #endregion
        #region 배경색 - BackgroundColor
    
        /// <summary>
        /// 배경색
        /// </summary>
        public Color BackgroundColor
        {
            get
            {
                return this.backgroundColor;
            }
        }

        #endregion
        #region 해시 스타일 - HatchStyle

        /// <summary>
        /// 해시 스타일
        /// </summary>
        public HatchStyle HatchStyle
        {
            get
            {
                return this.hatchStyle;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - HatchBrushItem(hatchStyle, foregroundColor, backgroundColor)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="hatchStyle">해시 스타일</param>
        /// <param name="foregroundColor">전경색</param>
        /// <param name="backgroundColor">배경색</param>
        public HatchBrushItem(HatchStyle hatchStyle, Color foregroundColor, Color backgroundColor)
        {
            this.hatchStyle      = hatchStyle;
            this.foregroundColor = foregroundColor;
            this.backgroundColor = backgroundColor;            
        }

        #endregion
    }
}