﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

			this.hatchRadioButton.Checked = true;

			this.hatchRadioButton.Tag       = BrushType.HATCH;
			this.systemColorRadioButton.Tag = BrushType.SYSTEM_COLOR;
			this.namedColorRadioButton.Tag  = BrushType.SOLID_COLOR;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 라디오 버튼 체크 변경시 처리하기 - RadioButton_CheckedChanged(sender, e)

        /// <summary>
        /// 라디오 버튼 체크 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
		private void RadioButton_CheckedChanged(object sender, EventArgs e)
		{
			RadioButton radioButton = sender as RadioButton;

			if(radioButton.Tag != null)
			{
				this.xPaintListBox.BrushType = (BrushType)radioButton.Tag;
			}
		}

        #endregion
    }
}